package com.gic.cloud.service;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.dto.IndexDescDTO;

import java.util.List;
import java.util.Map;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-07-23 14:50
 */
public interface IndexDescApiService {

    /**
     * 查询某个商户在某个模块下的指标
     * @Title: listByEnterpriseAndModule
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param moduleId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Map<String, List<IndexDescDTO>>> listByEnterpriseAndModule(Integer enterpriseId, String moduleId);

    /**
     * @Title: listByEnterpriseAndModuleDetail
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param moduleId
     * @return com.gic.api.base.commons.ServiceResponse<com.gic.cloud.dto.IndexEnterpriseGroupDTO>
     * @throws
     */
    ServiceResponse<Map<String, List<IndexDescDTO>>> listByEnterpriseAndModuleDetail(Integer enterpriseId, String moduleId, Integer userId);

    /**
     * 回收站中的指标
     * @Title: listRecycle
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param moduleId
     * @return com.gic.api.base.commons.ServiceResponse<com.gic.cloud.dto.IndexEnterpriseGroupDTO>
     * @throws
     */
    ServiceResponse<List<IndexDescDTO>> listRecycle(Integer enterpriseId, String moduleId);

    /**
     * 排序
     * @Title: sortIndex
     * @Description:
     * @author zhiwj
     * @param enterpriseId 商户id
     * @param moduleId
     * @param indexId 指标id
     * @param seq 排到第几个
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> sortIndex(Integer enterpriseId, String moduleId, Integer indexId, Integer seq);

    /**
     * 移动到回收站
     * @Title: moveToRecycle
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param moduleId
     * @param indexId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> moveToRecycle(Integer enterpriseId, String moduleId, Integer indexId);
}
