package com.gic.cloud.service.outer.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.dto.IndexDescDTO;
import com.gic.cloud.service.IndexDescApiService;
import com.gic.cloud.service.IndexDescService;
import com.gic.enterprise.response.EnterpriseServiceResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-07-23 15:10
 */
@Service("indexEnterpriseApiService")
public class IndexEnterpriseApiServiceImpl implements IndexDescApiService {

    @Autowired
    private IndexDescService indexDescService;

    @Override
    public ServiceResponse<Map<String, List<IndexDescDTO>>> listByEnterpriseAndModule(Integer enterpriseId, String moduleId) {
        List<IndexDescDTO> descList = indexDescService.listByEnterpriseAndModule(enterpriseId, moduleId);
        Map<String, List<IndexDescDTO>> resultMap = descList.stream().collect(Collectors.groupingBy(IndexDescDTO::getIndexGroupName, Collectors.mapping(e -> e, Collectors.toList())));
        return EnterpriseServiceResponse.success(resultMap);
    }

    @Override
    public ServiceResponse<Map<String, List<IndexDescDTO>>> listByEnterpriseAndModuleDetail(Integer enterpriseId, String moduleId, Integer userId) {
        List<IndexDescDTO> descList = indexDescService.listByEnterpriseAndModuleDetail(enterpriseId, moduleId, userId);
        Map<String, List<IndexDescDTO>> resultMap = descList.stream().collect(Collectors.groupingBy(IndexDescDTO::getIndexGroupName, Collectors.mapping(e -> e, Collectors.toList())));
        return EnterpriseServiceResponse.success(resultMap);
    }

    @Override
    public ServiceResponse<List<IndexDescDTO>> listRecycle(Integer enterpriseId, String moduleId) {
        return null;
    }

    @Override
    public ServiceResponse<Void> sortIndex(Integer enterpriseId, String moduleId, Integer indexId, Integer seq) {
        return null;
    }

    @Override
    public ServiceResponse<Void> moveToRecycle(Integer enterpriseId, String moduleId, Integer indexId) {
        return null;
    }
}
